<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:x="http://www.w3.org/TR/xpath"
                xmlns="http://www.w3.org/TR/xpath"
                exclude-result-prefixes="xalan x">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="/">
        <paths>
            <!-- for each end-of-path -->
            <xsl:for-each select="descendant::*
                [self::x:NameStep | self::x:TextNodeStep | self::x:CommentNodeStep | self::x:AllNodeStep]
                [not(
                    following-sibling::* | child::* |
                    ancestor::x:RelativeLocationPath/preceding-sibling::x:FilterExpr[x:VariableReference|x:Function]
                )]">
                <path absolute="{boolean(ancestor::x:AbsoluteLocationPath)}">
                    <xsl:apply-templates select="."/>
                </path>
            </xsl:for-each>
            <!-- for each end-of-path relative to current() -->
            <xsl:for-each select="descendant::x:FilterExpr[x:Function[@s1='current']]/following-sibling::x:RelativeLocationPath">
                <path absolute="false">
                    <xsl:copy-of select="x:*"/>
                </path>
            </xsl:for-each>
        </paths>
    </xsl:template>

    <xsl:template match="x:NameStep | x:TextNodeStep | x:CommentNodeStep | x:AllNodeStep">
        <!-- recursive -->
        <xsl:choose>
            <xsl:when test="preceding-sibling::*">
                <xsl:apply-templates select="preceding-sibling::*[1]"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="ancestor::x:NameStep[1]"/>
            </xsl:otherwise>
        </xsl:choose>
        <!-- current node -->
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates mode="filtered"/>
        </xsl:copy>
    </xsl:template>

    <!-- predicates -->
    <xsl:template match="x:NameStep | x:TextNodeStep | x:CommentNodeStep | x:AllNodeStep" mode="filtered"/>
    <xsl:template match="x:Predicate[preceding-sibling::x:VariableReference | preceding-sibling::x:Function]" mode="filtered"/>
    <xsl:template match="x:*" mode="filtered">
        <xsl:copy><xsl:copy-of select="@*"/>
            <xsl:apply-templates mode="filtered"/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>